import ConnectionStringUrl from 'mongodb-connection-string-url';
import { ConnectionInfo, ConnectionOptions } from 'mongodb-data-service';
import { ConnectionFormWarning } from '../utils/connect-form-warnings';
import { ConnectionFormError } from '../utils/connect-form-errors';
export interface ConnectFormState {
    connectionStringInvalidError: string | null;
    connectionOptions: ConnectionOptions;
    connectionStringUrl: ConnectionStringUrl;
    errors: ConnectionFormError[];
    warnings: ConnectionFormWarning[];
}
interface UpdateHostAction {
    type: 'update-host';
    hostIndex: number;
    newHostValue: string;
}
declare type ConnectionFormFieldActions = {
    type: 'add-new-host';
    hostIndexToAddAfter: number;
} | {
    type: 'remove-host';
    hostIndexToRemove: number;
} | UpdateHostAction | {
    type: 'update-direct-connection';
    isDirectConnection: boolean;
} | {
    type: 'update-connection-schema';
    isSrv: boolean;
};
export declare type UpdateConnectionFormField = (action: ConnectionFormFieldActions) => void;
export declare function handleConnectionFormFieldUpdate({ action, connectionStringUrl, connectionOptions, }: {
    action: ConnectionFormFieldActions;
    connectionStringUrl: ConnectionStringUrl;
    connectionOptions: ConnectionOptions;
}): {
    connectionStringUrl: ConnectionStringUrl;
    connectionOptions: ConnectionOptions;
    errors: ConnectionFormError[];
};
export declare function useConnectForm(initialConnectionInfo: ConnectionInfo): [
    ConnectFormState,
    {
        setConnectionStringError: (errorMessage: string | null) => void;
        setConnectionStringUrl: (connectionStringUrl: ConnectionStringUrl) => void;
        updateConnectionFormField: UpdateConnectionFormField;
        hideError: (index: number) => void;
        hideWarning: (index: number) => void;
    }
];
export {};
