"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.tryUpdateConnectionStringSchema = void 0;
const mongodb_connection_string_url_1 = __importDefault(require("mongodb-connection-string-url"));
const default_connection_1 = require("../constants/default-connection");
function updateConnectionStringToStandard(connectionStringUrl) {
    if (!connectionStringUrl.isSRV) {
        return connectionStringUrl;
    }
    const newConnectionString = connectionStringUrl.toString();
    const newConnectionStringUrl = new mongodb_connection_string_url_1.default(newConnectionString.replace('mongodb+srv://', 'mongodb://'));
    newConnectionStringUrl.hosts = [
        `${newConnectionStringUrl.hosts[0]}:${default_connection_1.defaultPort}`,
    ];
    return newConnectionStringUrl;
}
function updateConnectionStringToSRV(connectionStringUrl) {
    if (connectionStringUrl.isSRV) {
        return connectionStringUrl;
    }
    let newConnectionStringUrl = connectionStringUrl.clone();
    const newHost = newConnectionStringUrl.hosts.length > 0
        ? newConnectionStringUrl.hosts[0].substring(0, newConnectionStringUrl.hosts[0].indexOf(':') === -1
            ? undefined
            : newConnectionStringUrl.hosts[0].indexOf(':'))
        : default_connection_1.defaultHostname;
    newConnectionStringUrl.hosts = [newHost];
    const newConnectionString = newConnectionStringUrl.toString();
    newConnectionStringUrl = new mongodb_connection_string_url_1.default(newConnectionString.replace('mongodb://', 'mongodb+srv://'));
    if (newConnectionStringUrl.searchParams.get('directConnection')) {
        newConnectionStringUrl.searchParams.delete('directConnection');
    }
    return newConnectionStringUrl;
}
function tryUpdateConnectionStringSchema(connectionStringUrl, setIsSrv) {
    if (!setIsSrv) {
        return updateConnectionStringToStandard(connectionStringUrl);
    }
    else {
        return updateConnectionStringToSRV(connectionStringUrl);
    }
}
exports.tryUpdateConnectionStringSchema = tryUpdateConnectionStringSchema;
//# sourceMappingURL=connection-string-schema.js.map